disp('  ')
disp('PLEASE WAIT: The program needs to:')  
disp('run through the model harmonic constants,')
disp('interpolate the harmonic constants,')
disp('and make the timeseries.')

ipred=1;

latw1=str2num(get(g21a,'String')) + str2num(get(g21b,'String'))/60 ;
lonw1=str2num(get(g24a,'String')) + str2num(get(g24b,'String'))/60 ;
lontest=get(g24c,'String');
lattest=get(g21c,'String');

if lontest=='W' | lontest=='w',
lonw1=-lonw1;
elseif lontest=='E' | lontest=='e',
lonw1=lonw1;
else
disp(' ')
disp('Error in longitude E/W, 1st Instrument')
break
end

if lattest=='S' | lattest=='s',
latw1=-latw1;
elseif lattest=='N' | lattest=='n'
latw1=latw1;
else
disp(' ')
disp('Error in latitude N/S, 1st Instrument')
break
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
latw2=str2num(get(h21a,'String')) + str2num(get(h21b,'String'))/60 ;
lonw2=str2num(get(h24a,'String')) + str2num(get(h24b,'String'))/60 ;
lontest=get(h24c,'String');
lattest=get(h21c,'String');

if lontest=='W' | lontest=='w', 
lonw2=-lonw2;
elseif lontest=='E' | lontest=='e',
lonw2=lonw2;
else
disp(' ')
disp('Error in longitude E/W, 2nd Instrument')
break
end

if lattest=='S' | lattest=='s'
latw2=-latw2;
elseif lattest=='N' | lattest=='n'
latw2=latw2;
else
disp(' ')
disp('Error in latitude N/S, 2nd Instrument')
break
end

% now have (latw1,lonw1) and (latw2,lonw2) defined - these are the end points
% of the acoustic path.  If only one point is defined, make a prediction for
% that point only.  If both points are not defined, ask for an instrument
% location.
if (isnan(lonw1) | isnan(latw1)) & (~isnan(lonw2) & ~isnan(latw2)),
lonw=lonw2;
latw=latw2
elseif (isnan(lonw2) | isnan(latw2)) & (~isnan(lonw1) & ~isnan(latw1)),
lonw=lonw1;
latw=latw1
elseif (isnan(lonw1) | isnan(latw1)) | (isnan(lonw2) | isnan(latw2)),
disp(' ')
disp('Please define an instrument location')
break
else,
%         [RANGE,GLAT,GLONG]=DIST(LAT,LONG,N) computes N-point geodesics
%         between successive points. Each successive geodesic occupies
%         it's own row (N>=2)
AAA=[latw1 latw2];
BBB=[lonw1 lonw2];
NNN=str2num(get(h63b,'String'));
[r,latw,lonw]=dist(AAA,BBB,NNN);
%[RANGE,AF,AR]=DIST(LAT,LONG)
% now get the azimuthal angles along path.
AZ=[];
for i=1:(NNN-1),
   az1=getazimuth([latw(i) lonw(i)],[latw(i+1) lonw(i+1)]);
% getazimuth.m uses the function range(loc1,loc2) where loc1 is (lat,lon)
% getazimuth.m and range.m both assume a spherical earth, but this should 
% not be a bad approximation in this case.
% Azimuth is the bearing with respect to due north.  dist.m claims
% to calculate this, but I did not like the answers it gave...
   AZ=[AZ az1];
end
% add one more to make the dimensions the same as r, latw, lonw
AZ=(pi/180)*[AZ az1];

figure(1)
plot(lonw,latw,'r')
end


AG=[];
AGL=[];
%
%h and lat,lon; latu,lonu; latv;lonv are loaded in the initial program predict.m
%
% tm2 is M2 tidal period in hours
tm2=12.4206;
ts2=12.;
tn2=12.6583;
tk2=11.9672;
to1=25.8193;
tk1=23.9345;
tp1=24.0659;
tq1=26.8724;
tmf=13.66*24;
omegat=48.*pi./[tm2 ts2 tn2 tk2 to1 tk1 tp1 tq1];
% tmf];
% omegat has the tidal frequencies in rad/yearday.   

% the order of frequencies is M2, S2, N2, K2, O1, K1, P1, Q1, Mf
% ui,ur,vi,vr,eli,elr are all loaded in predict.m
for iop=1:8,
eval(['ui=ui'   num2str(iop) ';']);
eval(['ur=ur'   num2str(iop) ';']);
eval(['vi=vi'   num2str(iop) ';']);
eval(['vr=vr'   num2str(iop) ';']);
eval(['eli=eli' num2str(iop) ';']);
eval(['elr=elr' num2str(iop) ';']);

% WE WILL ONLY INTERPOLATE USING DATA WITHIN 2 GRID POINTS
% note there is potentially a problem near land because land has
% a value of zero for the tide - the interpolation will work using
% this value of zero.  Therefore, results within a grid point of
% land may be suspect.
%
DEL_LON=2*(lonu(1,2)-lonu(1,1));
DEL_LAT=2*(latu(2,1)-latu(1,1));
I1=((min(lonw)-DEL_LON) < lonu(1,:) & lonu(1,:) < (max(lonw)+DEL_LON)) ;
I2=((min(latw)-DEL_LAT) < latu(:,1) & latu(:,1) < (max(latw)+DEL_LAT));
if sum(I1)>=3 & sum(I2)>=3,

lon_tmp=lonu(I2,I1);
lat_tmp=latu(I2,I1);
ur_tmp=ur(I2,I1);
ui_tmp=ui(I2,I1);
UR=interp2(lon_tmp,lat_tmp,ur_tmp,lonw,latw,'*cubic');
UI=interp2(lon_tmp,lat_tmp,ui_tmp,lonw,latw,'*cubic');

I1=((min(lonw)-DEL_LON) < lonv(1,:) & lonv(1,:) < (max(lonw)+DEL_LON)) ;
I2=((min(latw)-DEL_LON) < latv(:,1) & latv(:,1) < (max(latw)+DEL_LON));
lon_tmp=lonv(I2,I1);
lat_tmp=latv(I2,I1);
vr_tmp=vr(I2,I1);
vi_tmp=vi(I2,I1); 
VR=interp2(lon_tmp,lat_tmp,vr_tmp,lonw,latw,'*cubic');
VI=interp2(lon_tmp,lat_tmp,vi_tmp,lonw,latw,'*cubic');

I1=((min(lonw)-DEL_LON) < lon(1,:) & lon(1,:) < (max(lonw)+DEL_LON)) ;
I2=((min(latw)-DEL_LAT) < lat(:,1) & lat(:,1) < (max(latw)+DEL_LAT));
lon_tmp=lon(I2,I1);
lat_tmp=lat(I2,I1);
h_tmp=h(I2,I1);
elr_tmp=elr(I2,I1);
eli_tmp=eli(I2,I1);
h14=interp2(lon_tmp,lat_tmp,h_tmp,lonw,latw,'*cubic');
Ar=interp2(lon_tmp,lat_tmp,elr_tmp,lonw,latw,'*cubic');
Ai=interp2(lon_tmp,lat_tmp,eli_tmp,lonw,latw,'*cubic');

UR=100*UR./h14;
UI=100*UI./h14;
% now project U onto the acoustic path.
% Gary uses opposite sign convention for phase...
U=UR.*sin(AZ)-j*UI.*sin(AZ);
UR=mean(UR);
UI=mean(UI);
U=mean(U);
Au14=sqrt(UR.^2 + UI.^2);
Gu14=atan2(-UI,UR)*(180/pi);

VR=100*VR./h14;
VI=100*VI./h14;
% now project V onto the acoustic path. 
% Gary uses opposite sign convention for phase...
V= VR.*cos(AZ)-j*VI.*cos(AZ);
VR=mean(VR);
VI=mean(VI);
Av14=sqrt(VR.^2 + VI.^2);
Gv14=atan2(-VI,VR)*(180/pi); 

% and U and V contributions.
U=U + V;

AA=Ar+j*Ai;

% now get the phase change on account of the finite time of
% propagation.
omega=omegat(iop);
% omega is in rad/days. Convert to rad/s.
omega=omega/(24*3600);
%RRR=exp(-j*omega*(r-r(length(r))/2)/1.48);
%r is in meters, so divide by 1480 m/s to get the approximate travel time in seconds.
RRR=exp(-j*omega*r/1480);

U=mean(U.*RRR);
% convert elevation from meters to cm.
AA=100*mean(AA.*RRR);

Ar=mean(Ar);
Ai=mean(Ai);
A=100*sqrt(Ar.^2 + Ai.^2);
% minus sign below because Gary's sign convention for phase is opposite
% to the rest of the world's.
G=(180/pi)*atan2(-Ai,Ar);

% the values of Au14 and Av14 are actually transports in m^2/s.  Divide by
% the model depth and multiply by 100 to convert to current in (cm/s)
Gu14( Gu14 > 360)=Gu14( Gu14 > 360)-360;
Gv14( Gv14 > 360)=Gv14( Gv14 > 360)-360;
Gu14( Gu14 <   0)=Gu14( Gu14 < 0  )+360;
Gv14( Gv14 <   0)=Gv14( Gv14 < 0  )+360;
G( G > 360)=G( G > 360)-360;
G( G <   0)=G( G < 0  )+360;

% Au14, Gu14, Av14, Gv14, A, G are the mean values over the acoustic path.
% Use these for plotting the ellipse at the mid-point of the path.
AG=[AG;[Au14 Gu14 Av14 Gv14 A G]];
AGL=[AGL;[U AA]];
else

ipred=0;
end

end

if ipred==1,
% plot the tidal ellipses of the desired constituent on figure 1.
figure(1)
Q=axis;
xscale=Q(2)-Q(1);
yscale=Q(4)-Q(3);
scale=min([xscale yscale]);

const=get(h61b,'String'); 
if sum(const~='Mf'),
tmptime=(0:(1/100):1.01)';
else
tmptime=(0:(1/10):13.7)';
end

const_scale=str2num(get(h62b,'String')) ;
%ACONST=['M2';'S2';'N2';'K2';'O1';'K1';'P1';'Q1';'Mf'];
%const1=ones(length(ACONST),1)*const;
%iconst=find(const1(:,1)==ACONST(:,1) & const1(:,2)==ACONST(:,2));
if const=='M2',
   iconst=1;
elseif const=='S2',
   iconst=2;
elseif const=='N2',
   iconst=3;
elseif const=='K2',
   iconst=4;
elseif const=='O1',
   iconst=5;
elseif const=='K1',
   iconst=6;
elseif const=='P1',
   iconst=7;
elseif const=='Q1',
   iconst=8;
elseif const=='Mf',
   iconst=9;
else
disp(' ')
disp('Not a valid constituent, use e.g., M2 or Q1')
disp(' ')
break
end
tsx=AG(iconst,1)*cos(omegat(iconst)*tmptime - (pi/180)*AG(iconst,2));
tsy=AG(iconst,3)*cos(omegat(iconst)*tmptime - (pi/180)*AG(iconst,4));
Ux=0.1*tsx*scale/const_scale;
Uy=0.1*tsy*scale/const_scale;

if length(lonw)==1,
lonwp=lonw;
latwp=latw;
else
I=round(length(lonw)/2);
lonwp=lonw(I);
latwp=latw(I);
end

plot(lonwp+Ux,latwp+Uy,'r')
plot(lonwp+Ux(1:5),latwp+Uy(1:5),'k','LineWidth',3)

plot([lonwp lonwp+Ux(1)],[latwp latwp+Uy(1)],'r')
plot([Q(2)-xscale*0.2 Q(2)-xscale*0.1 Q(2)-xscale*0.12],[Q(4)-yscale*0.1 Q(4)-yscale*0.1 Q(4)-yscale*0.08],'r')
text(Q(2)-xscale*0.2,Q(4)-xscale*0.06,[num2str(const_scale) ' cm/s'])
dz=str2num(get(h7,'String')) ;
title(['Contours in ' num2str(dz) ' m intervals; Tide prediction shows ' const ' current ellipses'])
disp('  ')
disp('Replot will clear all ellipses')
disp('  ')

figure(2)

% now pass AG or AGL to mktime
mktime

else
disp(' ')
disp('ERROR:  The point of interest is out of the range of tidal data.')
disp(' ')

end

