figure(3)
hold off
clf
figure(2)
hold off
clf
figure(1)
hold off
clf

%PATHCONSTS='../pacpred/pac';
PATHCONSTS='../hawpred/haw';
PATHSHORE='../shoreline';

%
%   BEGIN USER CONFIGURABLE OPTIONS
%
%
% WARNING:  The coast lines use 0 to -360 for longitude 
% initial plotting axis
A=[-166 -150 15 24];

%limits for lat,lon for which to save coastline
minlon=A(1);
maxlon=A(2);
minlat=A(3);
maxlat=A(4);
Year=2000;

if maxlon==0,
  maxlon=-0.04;
% this avoids the problem of the *.grd file ending at 359.967 rather than 360
end

% coast line filename
%coast=load('coast_world.dat');
eval(['load ' PATHSHORE '/high_res.mat'])
%now have latC,lonC

%load in all the tide data and the model bathymetry - 79MB
eval(['load ' PATHCONSTS '/allconsts.mat'])
% now have h, elr, eli, ur, ui, vr, vi defined for all 8 constituents.
if 1==2,
eval(['load ' PATHCONSTS '/eli.Mf_30'])
eli9=eli;
eval(['load ' PATHCONSTS '/elr.Mf_30'])
elr9=elr;
eval(['load ' PATHCONSTS '/ui.Mf_30'])
ui9=ui;
eval(['load ' PATHCONSTS '/ur.Mf_30'])
ur9=ur;
eval(['load ' PATHCONSTS '/vi.Mf_30'])
vi9=vi;
eval(['load ' PATHCONSTS '/vr.Mf_30'])
vr9=vr;
end

%load in the lat and lon values for h, el, u, v
eval(['load ' PATHCONSTS '/latlons.mat'])
%now have lat,lon; latu, lonu; latv; lonv

%
%   END USER CONFIGURABLE OPTIONS
%
%
% it works much faster when one chops to the minimal data one needs.

I=lonC==999;
% longitudes run from -370 to 0
% You wonder about the -370, no doubt - this is so as not
% to split Africa.
lonC(I)=nan*lonC(I);
latC(I)=nan*latC(I);
latC=latC/1000;
lonC=lonC/1000;   
I=lonC<minlon;
latC(I)=[];
lonC(I)=[];
I=maxlon<lonC;
latC(I)=[];
lonC(I)=[];
I=latC<minlat;
latC(I)=[];
lonC(I)=[];
I=maxlat<latC;
latC(I)=[];
lonC(I)=[];

lonc=lonC;
latc=latC;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
latw=[];
lonw=[];
AG=[];
F=[];
gflag=0;

plot(lonc,latc,'k')
axis('equal')
grid on
axis(A)
xlabel('Longitude')
ylabel('Latitude')
hold on

% redefine for plotting depth contours
lath=lat;
lonh=lon;
hh=h;

I=lonh(1,:)<minlon;
lath(:,I)=[];
lonh(:,I)=[];
hh(:,I)=[];
I=maxlon<lonh(1,:);
lath(:,I)=[];
lonh(:,I)=[];
hh(:,I)=[];
I=lath(:,1)<minlat;
lath(I,:)=[];
lonh(I,:)=[];
hh(I,:)=[];
I=maxlat<lath(:,1);
lath(I,:)=[];
lonh(I,:)=[];      
hh(I,:)=[];

V=0:1000:6000;
contour(lonh,lath,hh,V,'g')
axis(A)
title('Contours in 1000 m intervals')

scPos = get (0, 'screenSize');
hf1 = figure (1);
if scPos(4) >= 700
%   set (hf2, 'Position', [25 25 625 450]); y0 = -40;
   set (hf1, 'Position', [25 scPos(4)-600 600 550]); y0 = -40;
else
   set (hf1, 'Position', [25 scPos(4)-435 625 500]); y0 = -155;
end

hf2 = figure (2); hold off, clf
% put gui on upper left, covering most of window
%guiPos = round ([0.02 0.1 0.85 0.85] * scPos(4));
%set (hf1, 'Position', guiPos);
if scPos(4) >= 700
%   set (hf2, 'Position', [25 25 625 450]); y0 = -40;
   set (hf2, 'Position', [scPos(3)-525 150 500 525]); y0 = -40;
else
   set (hf2, 'Position', [25 scPos(4)-435 625 500]); y0 = -155;
end

hf3 = figure (3); hold off, clf
% put gui on upper left, covering most of window
%guiPos = round ([0.02 0.1 0.85 0.85] * scPos(4));
%set (hf1, 'Position', guiPos);
if scPos(4) >= 700
%   set (hf3, 'Position', [25 25 625 450]); y0 = -40;
   set (hf3, 'Position', [75 75 450 500]); y0 = -40;
else
   set (hf3, 'Position', [25 scPos(4)-435 625 500]); y0 = -155;
end

% now bring figure(1) back to the top
figure(1)

% and make figure(2) active for input
figure(2)

h10=uicontrol('Style','Pushbutton','Position',[20 465 50 30],'String','Min Lon','FontSize',9);
h20=uicontrol('Style','Pushbutton','Position',[75 465 50 30],'String','Max Lon','FontSize',9);
h30=uicontrol('Style','Pushbutton','Position',[130 465 50 30],'String','Min Lat','FontSize',9);
h40=uicontrol('Style','Pushbutton','Position',[185 465 50 30],'String','Max Lat','FontSize',9);
h70=uicontrol('Style','Pushbutton','Position',[240 465 40 30],'String','dz (m)','FontSize',9);
h50=uicontrol('Style','Pushbutton','Position',[350 465 100 30],'String','Year (1970-2037)','FontSize',9);
h1=uicontrol('Style','Edit','Position',[20 425 50 30],'String',num2str(A(1)),'FontSize',9);
h2=uicontrol('Style','Edit','Position',[75 425 50 30],'String',num2str(A(2)),'FontSize',9);
h3=uicontrol('Style','Edit','Position',[130 425 50 30],'String',num2str(A(3)),'FontSize',9);
h4=uicontrol('Style','Edit','Position',[185 425 50 30],'String',num2str(A(4)),'FontSize',9);
h7=uicontrol('Style','Edit','Position',[240 425 40 30],'String','1000','FontSize',9);
h6=uicontrol('Style','Pushbutton','Position',[285 425 50 30],'String','Replot','Callback','setaxis','FontSize',9);
h5=uicontrol('Style','Edit','Position',[375 425 50 30],'String',num2str(Year),'FontSize',9);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
g20=uicontrol('Style','Pushbutton','Position',[20  345 130 30],'String','Latitude for Prediction:','FontSize',9);
aa=uicontrol('Style','Pushbutton','Position', [160 380  70 20],'String','Decimal Deg.','FontSize',9);
g21a=uicontrol('Style','Edit','Position',     [160 345  70 30],'String','NaN','FontSize',9);
bb=uicontrol('Style','Pushbutton','Position', [240 380  70 20],'String','Decimal Min.','FontSize',9);
g21b=uicontrol('Style','Edit','Position',     [240 345  70 30],'String','NaN','FontSize',9);
g23=uicontrol('Style','Pushbutton','Position',[20  305  130 30],'String','Longitude for Prediction:','FontSize',9);
g24a=uicontrol('Style','Edit','Position',     [160 305  70 30],'String','NaN','FontSize',9);
g24b=uicontrol('Style','Edit','Position',     [240 305  70 30],'String','NaN','FontSize',9);
cc=uicontrol('Style','Pushbutton','Position', [310 380  50 20],'String','N/S;E/W','FontSize',9);
g21c=uicontrol('Style','Edit','Position',     [325 345  20 30],'String','N','FontSize',9);
g24c=uicontrol('Style','Edit','Position',     [325 305  20 30],'String','W','FontSize',9);
gz0=uicontrol('Style','Pushbutton','Position',[355 305 70 20],'String','Depth is (m):','FontSize',9) ;
gz=uicontrol('Style','Edit','Position',     [425 305  60 20],'String','-','FontSize',9);

g22a=uicontrol('Style','Pushbutton','Position',[360 345 60 30],'String','Plot','Callback','instr=0;,plotpos','FontSize',9);
g22b=uicontrol('Style','Pushbutton','Position',[425 345 60 30],'String','Graphical','Callback','instr=0;,gpos','FontSize',9);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h20=uicontrol('Style','Pushbutton','Position',[20  235 130 30],'String','Latitude for Prediction:','FontSize',9);
aa=uicontrol('Style','Pushbutton','Position', [160 270  70 20],'String','Decimal Deg.','FontSize',9);
h21a=uicontrol('Style','Edit','Position',     [160 235  70 30],'String','NaN','FontSize',9);
bb=uicontrol('Style','Pushbutton','Position', [240 270  70 20],'String','Decimal Min.','FontSize',9);
h21b=uicontrol('Style','Edit','Position',     [240 235  70 30],'String','NaN','FontSize',9);
h23=uicontrol('Style','Pushbutton','Position',[20  195  130 30],'String','Longitude for Prediction:','FontSize',9);
h24a=uicontrol('Style','Edit','Position',     [160 195  70 30],'String','NaN','FontSize',9);
h24b=uicontrol('Style','Edit','Position',     [240 195  70 30],'String','NaN','FontSize',9);
cc=uicontrol('Style','Pushbutton','Position', [310 270  50 20],'String','N/S;E/W','FontSize',9);
h21c=uicontrol('Style','Edit','Position',     [325 235  20 30],'String','N','FontSize',9);
h24c=uicontrol('Style','Edit','Position',     [325 195  20 30],'String','W','FontSize',9);
hz0=uicontrol('Style','Pushbutton','Position',[355 195 70 20],'String','Depth is (m):','FontSize',9) ;
hz=uicontrol('Style','Edit','Position',     [425 195  60 20],'String','-','FontSize',9);

h22a=uicontrol('Style','Pushbutton','Position',[360 235 60 30],'String','Plot','Callback','instr=1;,plotpos','FontSize',9);
h22b=uicontrol('Style','Pushbutton','Position',[425 235 60 30],'String','Graphical','Callback','instr=1;,gpos','FontSize',9);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


h61a=uicontrol('Style','Pushbutton','Position', [50  150 100 30],'String','Plot Ellipses for','FontSize',9);
h61b=uicontrol('Style','Edit','Position',      [152 150  30 30],'String','M2','FontSize',9);
h62a=uicontrol('Style','Pushbutton','Position', [190  150 85 30],'String','Ellipse Scale','FontSize',9);
h62b=uicontrol('Style','Edit','Position',      [277 150  30 30],'String','10','FontSize',9);
h63a=uicontrol('Style','Pushbutton','Position', [315  150 60 30],'String','No. Pts.','FontSize',9);
h63b=uicontrol('Style','Edit','Position',      [377 150  40 30],'String','30','FontSize',9);


h32=uicontrol('Style','Pushbutton','Position', [20  100 100 30],'String','Start Yearday=','FontSize',9);
h322=uicontrol('Style','Edit','Position',      [122 100  60 30],'String','','FontSize',9);
h33=uicontrol('Style','Pushbutton','Position', [195 100 100 30],'String','End Yearday=','FontSize',9);
h332=uicontrol('Style','Edit','Position',      [297 100  60 30],'String','','FontSize',9);
h331=uicontrol('Style','Pushbutton','Position',[370 100  90 30],'String','Get Prediction','Callback','getpred','FontSize',9);

h42=uicontrol('Style','Pushbutton','Position', [ 20 50 200 30],'String','Filename for harmonic constants:','FontSize',9);
h421=uicontrol('Style','Edit','Position',      [225 50 100 30],'String','','FontSize',9);
h422=uicontrol('Style','Pushbutton','Position',[330 50  90 30],'String','Save A,G','Callback','save_A_G','FontSize',9);

h52=uicontrol('Style','Pushbutton','Position', [ 20 10 200 30],'String','Filename for timeseries:','FontSize',9);
h521=uicontrol('Style','Edit','Position',      [225 10 100 30],'String','','FontSize',9);
h522=uicontrol('Style','Pushbutton','Position',[330 10  90 30],'String','Save Timeseries','Callback','save_time','FontSize',9);


