%this calculates the range in kilometers between locations in degrees lat, lon
%define loc1 and loc2 in lat, lon (degrees)
%call via:  x=range(loc1,loc2);
%loc2 can be a column vector of [lat lon];
%uses spherical earth
function y=range(loc1,loc2);
R=6370.1;
torad=pi/180;
loc1=loc1*torad;
loc2=loc2*torad;
loc1=ones(size(loc2(:,1)))*loc1;
lats=loc1(:,1);
lons=loc1(:,2);
latf=loc2(:,1);
lonf=loc2(:,2);
n1=cos(lats).*sin(lons).*sin(latf)-sin(lats).*cos(latf).*sin(lonf);
n2=sin(lats).*cos(latf).*cos(lonf)-cos(lats).*cos(lons).*sin(latf);
n3=(cos(lons).*sin(lonf)-sin(lons).*cos(lonf)).*cos(lats).*cos(latf);
n=[n1 n2 n3];
x=[cos(lats).*cos(lons) cos(lats).*sin(lons) sin(lats)];
x1=x(1);
x2=x(2);
x3=x(3);
xf=[cos(latf).*cos(lonf) cos(latf).*sin(lonf) sin(latf)];
Delx=xf-x;
thetaT=acos(sum((x.*xf)')');
y=thetaT*R;
